KeyDownGoal = {}
KeyDownGoalMT = { __index = KeyDownGoal }

setmetatable ( KeyDownGoal, { __index = Goal } )
goals['KeyDown'] = KeyDownGoal

function KeyDownGoal:Create ( key )
	local goal = {}
	setmetatable ( goal, KeyDownGoalMT )

	goal.key = key

	return goal
end
function KeyDownGoal:Destroy ( )
	self.key = nil
end
function KeyDownGoal:GetType ( )
    return 'KeyDown'
end
function KeyDownGoal:Process ( delta, owner )
    if keyboard:is_down ( self.key ) == true then
        return GOAL_COMPLETED, 0
    end
	return GOAL_ACTIVE, delta
end
function KeyDownGoal:CreateXML ( goal )
	local key = goal.key
	local g = KeyDownGoal:Create ( key )
	return g
end
function KeyDownGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.key = self.key
	return g
end

