Bullet = {}
BulletMT = { __index = Bullet }

function Bullet:Create ( world, type, position, angle, distance, speed, msg, popMSG )
    local name = world:GetAvailableName ( )
    local body = world:CreateBody ( name, position, angle, 0, 0, false, false, false, false )
	--shape:SetFilter ( 2, 0x0008, 65535 )

	--body:SetScale ( 0.1 )
	if type == 'bullet' then
	    local shape = body:CreateShapeCircle ( 0.1, b2Vec2 ( 0, 0 ), 0.1, 0, 0, true )
    	body:SetGoal ( BulletGoal:Create ( angle, distance, speed, msg, popMSG ) )
    	body:SetImage ( 'Images/explosion/bullet.png' )
    elseif type == 'fire' then
	    local shape = body:CreateShapeCircle ( 0.3, b2Vec2 ( 0, 0 ), 0.01, 0, 0, true )
        body:SetGoal ( FireBulletGoal:Create ( angle, distance, speed, msg, popMSG ) )
    elseif type == 'missle' then
        
    elseif type == 'granade' then
    
    else
        assert ( false )
    end
--[[
	local lv = b2Vec2 ( 0, speed )
	lv:SetAngle ( angle )
	body.b2body:SetLinearVelocity ( lv )
]]
	body.sprite:set_scale ( 0.1, 0.1 )
	body.sprite.depth = -5
	
	return body
end


BulletGoal = {}
BulletGoalMT = { __index = BulletGoal }

function BulletGoal:Create ( angle, distance, speed, msg, popMSG )
    local pop = SequenceGoal:Create ( false )
    pop:PushBack ( MessageReceiveGoal:Create ( popMSG ) )
    pop:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'bullet', 0.5 ) )
    pop:PushBack ( PlaySound2DGoal:Create ( 'Sounds/shoot.wav', 0, 1, 1 ) )
    pop:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
pop:PushBack ( FailGoal:Create ( ) )
    local live = SequenceGoal:Create ( false )
	live:PushBack ( WaitGoal:Create ( distance / speed - 0.5 ) )
	live:PushBack ( FadeGoal:Create ( 0, 0.25 ) )
    live:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
live:PushBack ( FailGoal:Create ( ) )
    local hit = SequenceGoal:Create ( true )
    hit:PushBack ( MessageSendGoal:Create ( "contacts", msg ) )
    hit:PushBack ( CompleteGoal:Create ( ) )
    local move = MoveLVGoal:Create ( 'self', b2Vec2 ( 0, 100 ), speed )
	local bullet = ParallelGoal:Create ( false )
    bullet:PushBack ( move )
	bullet:PushBack ( live )
    bullet:PushBack ( hit )
	bullet:PushBack ( pop )

	return bullet
end


FireBulletGoal = {}
FireBulletGoalMT = { __index = FireBulletGoal }

function FireBulletGoal:Create ( angle, distance, speed, msg, popMSG )

    local d = distance / speed / 9
    local live = SequenceGoal:Create ( false )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire1.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire2.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire3.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire4.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire5.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire6.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire7.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire8.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/fire9.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
live:PushBack ( FailGoal:Create ( ) )
    local pop = SequenceGoal:Create ( false )
    pop:PushBack ( MessageReceiveGoal:Create ( popMSG ) )
    pop:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'bullet', 0.5 ) )
    --pop:PushBack ( PlaySound2DGoal:Create ( 'Sounds/shoot.wav', 0, 1, 0.2 ) )
    pop:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
pop:PushBack ( FailGoal:Create ( ) )
    local hit = SequenceGoal:Create ( true )
    hit:PushBack ( MessageSendGoal:Create ( "contacts", msg ) )
    hit:PushBack ( CompleteGoal:Create ( ) )
    
    local move = MoveLVGoal:Create ( 'self', b2Vec2 ( 0, 100 ), speed )
	local bullet = ParallelGoal:Create ( false )
    bullet:PushBack ( move )
	bullet:PushBack ( hit )
	bullet:PushBack ( pop )
	bullet:PushBack ( live )
	return bullet
end






