
function CreateElevatorV ( world, x, y, dx, dy, s )
    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( x, y )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
    b.sprite:set_scale ( 0.1, 0.1 )

    local v = { b2Vec2 ( -1.6, 1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( 1.6, -4.8 ), b2Vec2 ( -1.6, -4.8 ) }
    b:CreateShapePolygon ( v, 0, 0.5, 0, false )
    b:SetImage ( "Images/tileset/elevatorV.png", 0, -16 )

    local p1 = b2Vec2 ( p.x, p.y )
    local p2 = b2Vec2 ( p.x + dx, p.y + dy )
    local g = SequenceGoal:Create ( true )
    g:PushBack ( MovePlatformGoal:Create ( 'world', p1, s ) )
    g:PushBack ( MovePlatformGoal:Create ( 'world', p2, s ) )
    local s = SequenceGoal:Create ( true )
    s:PushBack ( SetImageGoal:Create ( "Images/tileset/elevatorV.png", 0, -16 ) )
    s:PushBack ( WaitGoal:Create ( 0.15 ) )
    s:PushBack ( SetImageGoal:Create ( "Images/tileset/elevatorV2.png", 0, -16 ) )
    s:PushBack ( WaitGoal:Create ( 0.15 ) )
    local p = ParallelGoal:Create ( true )
    p:PushBack ( g )
    p:PushBack ( s )
    b:SetGoal ( p )
    
    b.sprite.depth = -0.5
end

