FunctionGoal = {}
FunctionGoalMT = { __index = FunctionGoal }

setmetatable ( FunctionGoal, { __index = Goal } )
goals['function'] = FunctionGoal

function FunctionGoal:Create ( name )
	local goal = {}
	setmetatable ( goal, FunctionGoalMT )

	goal.name = name

	return goal
end
function FunctionGoal:Destroy ( )
	self.name = nil
end
function FunctionGoal:GetType ( )
    return 'function'
end
function FunctionGoal:Process ( delta, owner )
	local f = _G[self.name] ( )

	return GOAL_COMPLETED, 0
end
function FunctionGoal:CreateXML ( goal )
	local g = FunctionGoal:Create ( goal.name )
	return g
end
function FunctionGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.name = self.name
	return g
end






