Granade = {}
GranadeMT = { __index = Missle }

function Granade:Create ( world, name, position, angle, distance, speed, msg, popMSG )
    local body = world:CreateBody ( name, position, angle, 0, 0, false, false, false, false )
body.passThrough = true
	local shape = body:CreateShapeCircle ( 0.3, b2Vec2 ( 0, 0 ), 5, 0.5, 0.5, false )

	body:SetImage ( "Images/explosion/granade.png" )
	body.sprite:set_scale ( 0.1, 0.1 )
	body.sprite.depth = -5

	local lv = b2Vec2 ( 0, speed * 1 )
	lv:SetAngle ( angle )
	body.b2body:SetLinearVelocity ( lv )
	
	body.b2body:SetAngularVelocity ( math.pi / 2 )

    local hit = SequenceGoal:Create ( true )
    hit:PushBack ( MessageSendGoal:Create ( "contacts", msg ) )
    hit:PushBack ( CompleteGoal:Create ( ) )
    
    local takeHit = SequenceGoal:Create ( false )
    takeHit:PushBack ( MessageReceiveGoal:Create ( 'damage' ) )
    takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'medium', 0.6, msg ) )
    takeHit:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_granade.wav" ) )
    takeHit:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
takeHit:PushBack ( FailGoal:Create ( ) )
    local pop = SequenceGoal:Create ( false )
    pop:PushBack ( MessageReceiveGoal:Create ( popMSG ) )
    pop:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'medium', 0.6, msg ) )
    pop:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_granade.wav" ) )
    --pop:PushBack ( PlaySound2DGoal:Create ( 'Sounds/shoot.wav', 0, 1, 1 ) )
    pop:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
pop:PushBack ( FailGoal:Create ( ) )
    local attack = ParallelGoal:Create ( true )
    attack:PushBack ( hit )
    attack:PushBack ( takeHit )
    attack:PushBack ( pop )

    local fadeOut = SequenceGoal:Create ( false )
    fadeOut:PushBack ( WaitGoal:Create ( distance / speed ) )
    fadeOut:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'medium', 0.6, msg ) )
    fadeOut:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_granade.wav" ) )
    fadeOut:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
fadeOut:PushBack ( FailGoal:Create ( ) )
    local live = ParallelGoal:Create ( false )
    live:PushBack ( attack )
    live:PushBack ( fadeOut )

	body:SetGoal ( live )

	return body
end