
function CreateMachineGunner ( world, b, p )
    local v = { b2Vec2 ( -1.6, 0.95 ), b2Vec2 ( 0, 0.95 ), b2Vec2 ( 0, -1.6 ), b2Vec2 ( -1.6, -1.6 ) }
    b:CreateShapePolygon ( v, 0, 1, 0, true )
    b:SetImage ( "Images/soldier/machinegunner1.png" )

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local die = SequenceGoal:Create ( true )
    die:PushBack ( MessageReceiveGoal:Create ( 'die' ) )
die:PushBack ( ShootGoal:Create ( 'powerup', b2Vec2 ( 1, -0.4 ), 0, 0, 0, 'random', 0 ) )

    die:PushBack ( SetImageGoal:Create ( "Images/soldier/machinegunner0.png" ) )
    die:PushBack ( DestroyAllShapesGoal:Create ( ) )
    die:PushBack ( FailGoal:Create ( ) )
    
    local shoot = SequenceGoal:Create ( true )
    for i = 1, 3, 1 do
        shoot:PushBack ( PlaySound2DGoal:Create ( 'Sounds/explode3.wav' ) )
        shoot:PushBack ( SetImageGoal:Create ( "Images/soldier/machinegunner1.png" ) )
        shoot:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -1.7, 0.6 ), 'spark', 0.3 ) )
        shoot:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -1.7, 0.6 ), math.pi / 2, 3.2 * 15, 12, 'damage', 'touch' ) )
        shoot:PushBack ( WaitGoal:Create ( 0.1 ) )
        shoot:PushBack ( SetImageGoal:Create ( "Images/soldier/machinegunner2.png" ) )
        shoot:PushBack ( WaitGoal:Create ( 0.1 ) )
        shoot:PushBack ( SetImageGoal:Create ( "Images/soldier/machinegunner3.png" ) )
        shoot:PushBack ( WaitGoal:Create ( 0.1 ) )
    end
    shoot:PushBack ( WaitGoal:Create ( 2 ) )
    
    local attack = SequenceGoal:Create ( true )
    attack:PushBack ( RangeGoal:Create ( 'player', 7 * 3.2, 'player2' ) )
    attack:PushBack ( shoot )

    local g = ParallelGoal:Create ( true )
    g:PushBack ( pop )
    g:PushBack ( attack )
    g:PushBack ( die )
    
    b:SetGoal ( g )

    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( p.x + 1.5, p.y )
    local body = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
    body.sprite:set_scale ( -0.1, 0.1 )
    local v = { b2Vec2 ( -1.7, 1.4 ), b2Vec2 ( 0, 1.4 ), b2Vec2 ( 0, -1.6 ), b2Vec2 ( -1.7, -1.6 ) }
    body:CreateShapePolygon ( v, 0, 0, 0, true )
    body:Paint ( )
--body.sprite.depth = p.y / ( #map * 3.2 )
    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local die = SequenceGoal:Create ( false )
    die:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    die:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    die:PushBack ( MessageSendGoal:Create ( b.name, 'die' ) )
    die:PushBack ( DestroyAllShapesGoal:Create ( ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die1.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die2.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die3.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die4.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die5.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die6.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die7.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die8.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.5 ) )
    die:PushBack ( FadeGoal:Create ( 0, 0.5 ) )
    die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

    local p = ParallelGoal:Create ( false )
    p:PushBack ( pop )
    p:PushBack ( die )

    body:SetGoal ( p )
    
    return b
end


