
function CreateTurret2 ( world, x, y )
    local position = b2Vec2 ( x, y )
    local angle = 0
    local range = 3.2 * 6
    local bulletSpeed = 10



	local baseName = world:GetAvailableName ( )
	local base = world:CreateBody ( baseName, b2Vec2 ( position ), 0, 0, 0, false, false, true, false )
	base:CreateShapeCircle ( range, b2Vec2 ( 0, 0 ), 0, 0, 0, true )
base:SetImage ( "Images/turret/turretBase.png" )
base.sprite.depth = -10
base.sprite:set_scale ( 0.1, 0.1 )
    
    local die = SequenceGoal:Create ( false )
    for i = 1, 3, 1 do
        die:PushBack ( MessageReceiveGoal:Create ( 'cannonShot' ) )
        die:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
        die:PushBack ( SetImageGoal:Create ( 'Images/turret/turretBaseF.png' ) )
        die:PushBack ( WaitGoal:Create ( 0.05 ) )
        die:PushBack ( SetImageGoal:Create ( 'Images/turret/turretBase.png' ) )
    end
    die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
die:PushBack ( FailGoal:Create ( ) )
    base:SetGoal ( die )


    local name = world:GetAvailableName ( )
    local body = world:CreateBody ( name, position, angle, 0, 0, false, false, false, false )
	body:CreateShapeCircle ( 1.6, b2Vec2 ( 0, 0 ), 1, 0.5, 0.5, true )

body:SetImage ( "Images/turret/turretCannon.png" )
body.sprite:set_scale ( 0.1, 0.1 )
body.sprite.depth = -9
	world:CreateJointRevolute ( body, base, false, b2Vec2 ( position ) )

    local attack = SequenceGoal:Create ( true )
    attack:PushBack ( SenseGoal:Create ( baseName, 'player', true, 'player2' ) )
    attack:PushBack ( WaitGoal:Create ( 1.5 ) )
    attack:PushBack ( AimTorqueGoal:Create ( 'player', 0.75, 1.5, 20000, true, 'player2' ) )
    attack:PushBack ( StopGoal:Create ( ) )
    attack:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( 0, 1.6 ), 0, range, bulletSpeed, 'damage', 'touch' ) )

    local die = SequenceGoal:Create ( false )
    for i = 1, 3, 1 do
        die:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
        die:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )

        die:PushBack ( MessageSendGoal:Create ( baseName, 'cannonShot' ) )
        die:PushBack ( SetImageGoal:Create ( 'Images/turret/turretCannonF.png' ) )
        die:PushBack ( WaitGoal:Create ( 0.05 ) )
        die:PushBack ( SetImageGoal:Create ( 'Images/turret/turretCannon.png' ) )
    end
    local e = math.random ( 4 )
    die:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med" .. e .. ".wav", 0, 1, 1 ) )
    die:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.7 ) )
    --die:PushBack ( WaitGoal:Create ( 0.02 ) )
    die:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.2, -0.8 ), 'small', 0.6 ) )
    --die:PushBack ( WaitGoal:Create ( 0.01 ) )
    die:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.4, 1.2 ), 'small', 0.8 ) )

    die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
die:PushBack ( FailGoal:Create ( ) )
    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local goal = ParallelGoal:Create ( true )
    goal:PushBack ( attack )
    goal:PushBack ( die )
    goal:PushBack ( pop )
    body:SetGoal ( goal )
end