function CreateWindow ( world, p )
    local n = world:GetAvailableName ( )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, true, false, false )
    b:Paint ( )
    b.sprite:set_scale ( 0.1, 0.1 )

    local f = math.random ( 1, 7 )
    local s = SequenceGoal:Create ( true )
    for i = f + 1, 7, 1 do
        s:PushBack ( SetImageGoal:Create ( "Images/tileset2/w" .. i .. ".png" ) )
        s:PushBack ( WaitGoal:Create ( 0.05 ) )
    end
    for i = 1, f, 1 do
        s:PushBack ( SetImageGoal:Create ( "Images/tileset2/w" .. i .. ".png" ) )
        s:PushBack ( WaitGoal:Create ( 0.05 ) )
    end
    b:SetGoal ( s )
    
    return b
end

function CreateSmallWindow ( world, p )
    local n = world:GetAvailableName ( )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, true, false, false )
    b:Paint ( )
    b.sprite:set_scale ( 0.1, 0.1 )

    local f = math.random ( 1, 6 )
    local s = SequenceGoal:Create ( true )
    for i = f + 1, 6, 1 do
        s:PushBack ( SetImageGoal:Create ( "Images/tileset2/sw" .. i .. ".png" ) )
        s:PushBack ( WaitGoal:Create ( 0.05 ) )
    end
    for i = 1, f, 1 do
        s:PushBack ( SetImageGoal:Create ( "Images/tileset2/sw" .. i .. ".png" ) )
        s:PushBack ( WaitGoal:Create ( 0.05 ) )
    end
    b:SetGoal ( s )
    
    return b
end