function CreateWindowSoldier ( world, b, p )
    local trigger = b2Vec2 ( p.x - 3.2 * 2, p.y )
    local triggerName = world:GetAvailableName ( )
    local body = world:CreateBody ( triggerName, trigger, 0, 0, 0, true, true, false, false )
    local v = { b2Vec2 ( -1.6, -1.6 * 10 ), b2Vec2 ( 1.6 * 4, -1.6 * 10 ), b2Vec2 ( 1.6 * 4, 1.6 * 10 ), b2Vec2 ( -1.6, 1.6 * 10 ) }
	local trigger = body:CreateShapePolygon ( v, 0, 0, 0, true )
    body:Paint ( )
    body.sprite:set_scale ( 0.1, 0.1 )

    b:CreateShapeCircle ( 0.8, b2Vec2 ( 0, 0 ), 0, 0, 0, true )

    local splash = SequenceGoal:Create ( false )
    splash:PushBack ( SenseGoal:Create ( triggerName, 'player', true, 'player2' ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win1.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win2.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win3.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win4.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win5.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win6.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win7.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win8.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win9.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( SetImageGoal:Create ( "Images/train/win10.png" ) )
    splash:PushBack ( WaitGoal:Create ( 0.05 ) )
    splash:PushBack ( FailGoal:Create ( ) )

    local lean = SequenceGoal:Create ( false )
    lean:PushBack ( SetImageGoal:Create ( "Images/train/win11.png" ) )
    lean:PushBack ( WaitGoal:Create ( 0.05 ) )
    lean:PushBack ( SetImageGoal:Create ( "Images/train/win12.png" ) )
    lean:PushBack ( WaitGoal:Create ( 0.05 ) )
    lean:PushBack ( SetImageGoal:Create ( "Images/train/win13.png" ) )
    lean:PushBack ( WaitGoal:Create ( 0.05 ) )
    lean:PushBack ( SetImageGoal:Create ( "Images/train/win14.png" ) )
    lean:PushBack ( WaitGoal:Create ( 0.05 ) )
    lean:PushBack ( SetImageGoal:Create ( "Images/train/win15.png" ) )
    lean:PushBack ( WaitGoal:Create ( 0.05 ) )
    
    local fire = SequenceGoal:Create ( true )
    fire:PushBack ( SetImageGoal:Create ( "Images/train/win16.png" ) )
    fire:PushBack ( WaitGoal:Create ( 0.1 ) )
    fire:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.1, 1.8 ), 'spark', 0.3 ) )
    fire:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -0.1, 1.8 ), 0, 3.2 * 15, 12, 'damage', 'touch' ) )
    fire:PushBack ( SetImageGoal:Create ( "Images/train/win17.png" ) )
    fire:PushBack ( WaitGoal:Create ( 0.1 ) )
    fire:PushBack ( SetImageGoal:Create ( "Images/train/win18.png" ) )
    fire:PushBack ( WaitGoal:Create ( 0.5 ) )
    
    local attack = SequenceGoal:Create ( false )
    attack:PushBack ( lean )
    attack:PushBack ( fire )
    
    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )
    
    local takeHit = SequenceGoal:Create ( false )
    takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'smokey', 0.5 ) )
    takeHit:PushBack ( FailGoal:Create ( ) )
    
    local p = ParallelGoal:Create ( true )
    p:PushBack ( attack )
    p:PushBack ( pop )
    p:PushBack ( takeHit )
    
    local ps = PrioritySelectorGoal:Create ( false )
    ps:PushBack ( splash )
    ps:PushBack ( p )
    ps:PushBack ( SetImageGoal:Create ( "Images/train/win10.png" ) )

    b:SetGoal ( ps )
    
    return b
end