
function CreateLTurret ( world, x, y )
    local sn = world:GetAvailableName ( )
    local p = b2Vec2 ( x, y + 0.85 )
    local b = world:CreateBody ( sn, p, 0, 0, 0, true, false, false, false )
    local v = { b2Vec2 ( -1.6 * 8, 1.6 * 2 ), b2Vec2 ( 1.6, 1.6 * 2 ), b2Vec2 ( 1.6, -1.6 * 2 ), b2Vec2 ( -1.6 * 8, -1.6 * 2 ) }
    b:CreateShapePolygon ( v, 0, 0, 0, true )
    b.sprite:set_scale ( 0.1, 0.1 )

    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( x, y + 0.85 )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
    local v = { b2Vec2 ( 0.5, 0.4 ), b2Vec2 ( 1.6, 0.4 ), b2Vec2 ( 1.6, -2.6 ) }
    b:CreateShapePolygon ( v, 0, 0, 0, true )
    b.sprite:set_scale ( 0.1, 0.1 )

    local g = SequenceGoal:Create ( true )
    g:PushBack ( SetImageGoal:Create ( 'Images/turret/lt1.png' ) )
    g:PushBack ( SenseGoal:Create ( sn, 'player', true, 'player2' ) )
    g:PushBack ( SetImageGoal:Create ( 'Images/turret/lt2.png' ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( 'Images/turret/lt3.png' ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( 'Images/turret/lt4.png' ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( 'Images/turret/lt5.png' ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( 'Images/turret/lt6.png' ) )

    g:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_splash.wav" ) )

    local a = math.pi / 2
    local d = 40
    local s = 20
    local p = b2Vec2 ( -0.2, 0 )
    g:PushBack ( ExplodeGoal:Create ( p, 'smokey', 0.75 ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 3, s / 2, 'damage', 'touch' ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    g:PushBack ( WaitGoal:Create ( 0.2 ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 3, s / 2, 'damage', 'touch' ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    g:PushBack ( WaitGoal:Create ( 0.2 ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 3, s / 2, 'damage', 'touch' ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    g:PushBack ( WaitGoal:Create ( 0.2 ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    g:PushBack ( WaitGoal:Create ( 0.2 ) )
    g:PushBack ( ShootGoal:Create ( 'fire', p, a, d / 5, s / 1.5, 'damage', 'touch' ) )

    g:PushBack ( WaitGoal:Create ( 2 ) )

    
    local die = SequenceGoal:Create ( false )
    for i = 1, 3, 1 do
        die:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
        die:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
        die:PushBack ( SetImageGoal:Create ( 'Images/turret/lt1F.png' ) )
        die:PushBack ( WaitGoal:Create ( 0.1 ) )
        die:PushBack ( SetImageGoal:Create ( 'Images/turret/lt1.png' ) )
    end

    local e = math.random ( 4 )
    die:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med" .. e .. ".wav", 0, 1, 1 ) )
    die:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.5, 0 ), 'small', 0.7 ) )
    die:PushBack ( WaitGoal:Create ( 0.02 ) )
    die:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.8, -0.8 ), 'small', 0.6 ) )
    die:PushBack ( WaitGoal:Create ( 0.01 ) )
    die:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.4, 1.2 ), 'small', 0.8 ) )
    die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
die:PushBack ( FailGoal:Create ( ) )
    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local p = ParallelGoal:Create ( true )
    p:PushBack ( g )
    p:PushBack ( die )
    p:PushBack ( pop )
    
    b:SetGoal ( p )
    b.sprite.depth = -0.5
end
