function CreateTurboGunner ( world, b, p )
    local v = { b2Vec2 ( -1.6, 0.95 ), b2Vec2 ( 0, 0.95 ), b2Vec2 ( 0, -1.6 ), b2Vec2 ( -1.6, -1.6 ) }
    b:CreateShapePolygon ( v, 0, 1, 0, true )
    b:SetImage ( "Images/turbo/tbase.png" )

    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( p.x, p.y )
    local body = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
    body.sprite:set_scale ( 0.1, 0.1 )
    body:CreateShapeCircle ( 0.8, b2Vec2 ( 1.1, 0.8 ), 0, 0, 0, true )
    body:Paint ( )
    body.sprite.depth = -0.9
    body:SetImage ( "Images/turbo/t1.png" )

    local shoot = SequenceGoal:Create ( true )
    shoot:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 0, 2.6 ), 4 ) )
    shoot:PushBack ( SetImageGoal:Create ( 'Images/turbo/t1.png' ) )
    shoot:PushBack ( WaitGoal:Create ( 0.1 ) )
    shoot:PushBack ( SetImageGoal:Create ( 'Images/turbo/t2.png' ) )
    shoot:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -2.6, 0.5 ), 'spark', 0.3 ) )
    shoot:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -2.6, 0.5 ), math.pi / 2, 3.2 * 15, 12, 'damage', 'touch' ) )
    shoot:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -2.6, -0.4 ), 'spark', 0.3 ) )
    shoot:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -2.6, -0.4 ), math.pi / 2, 3.2 * 15, 12, 'damage', 'touch' ) )
    shoot:PushBack ( WaitGoal:Create ( 0.25 ) )
    shoot:PushBack ( SetImageGoal:Create ( 'Images/turbo/t1.png' ) )
    shoot:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 0, -2.6 ), 4 ) )
    shoot:PushBack ( SetImageGoal:Create ( 'Images/turbo/t2.png' ) )
    shoot:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -2.6, 0.5 ), 'spark', 0.3 ) )
    shoot:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -2.6, 0.5 ), math.pi / 2, 3.2 * 15, 12, 'damage', 'touch' ) )
    shoot:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -2.6, -0.4 ), 'spark', 0.3 ) )
    shoot:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -2.6, -0.4 ), math.pi / 2, 3.2 * 15, 12, 'damage', 'touch' ) )
    shoot:PushBack ( WaitGoal:Create ( 0.25 ) )
    shoot:PushBack ( SetImageGoal:Create ( 'Images/turbo/t1.png' ) )

    local attack = SequenceGoal:Create ( false )
    attack:PushBack ( RangeGoal:Create ( 'player', 3.2 * 7, 'player2' ) )
    attack:PushBack ( shoot )

    body:SetGoal ( attack )

    return b
end


