require ( "lfs" )

function dodir ( path, recursive )
	for file in lfs.dir ( path ) do
		if file ~= '.' and file ~= '..' then
		    local fullPath = path .. '/' .. file
			local attr = lfs.attributes ( fullPath )
			if attr.mode == 'directory' then
				if recursive == true then
				    dodir ( fullPath, recursive )
				end
			else
			    if string.len ( file ) > 4 then
			        local extension = string.sub ( file, -4, -1 )
			        extension = string.lower ( extension )
			        if extension == '.lua' then
    			        dofile ( fullPath )
    			    end
			    end
			end
		end
	end
end